import RPi._GPIO as GPIO
from mfrc522 import SimpleMFRC522
import asyncio

class RFIDDriver:
    def __init__(self):
        self.reader = SimpleMFRC522()

    def __del__(self):
        GPIO.cleanup()
    
    async def get_next_id(self) -> int:
        id = self.reader.read_id_no_block()
        while not id:
            id = self.reader.read_id_no_block()
            await asyncio.sleep(0.01)
        return id